package SearchConditionAppender::Tag;

use strict;

sub hdlr_search_condition_script_thunk {
    my ( $ctx, $args, $cond ) = @_;

    return '' if is_limit();
    my $blog = $ctx->stash('blog');

    my $plugin = MT->component("SearchConditionAppender");
    my $condition = ' ' . $plugin->get_config_value('condition', 'blog:'.$blog->id);
    (my $condition2 = $condition) =~ s/\:/\\:/;
    $condition = '' if $condition eq ' ';
    $condition2 = '' if $condition2 eq ' ';

    my $script = <<EOF;
<script>
function add_condition() {
    search_dummy = document.getElementById('search_dummy').value;
    document.getElementById('search').value = search_dummy + '$condition';
}
exec_search = document.getElementById('exec_search');
exec_search.setAttribute("onclick","add_condition()");
</script>
EOF
    return $script;
}

sub hdlr_search_condition_input_thunk {
    my ( $ctx, $args, $cond ) = @_;

    return '' if is_limit();
    my $blog = $ctx->stash('blog');

    my $search_string = $ctx->stash( 'search_string' );

    my $plugin = MT->component("SearchConditionAppender");
    my $condition = ' ' . $plugin->get_config_value('condition', 'blog:'.$blog->id);
    (my $search_string2 = $search_string) =~ s/$condition//;

    my $input = <<EOF;
<input type="text_dummy" id="search_dummy" class="ti" name="search_dummy" value="$search_string2" />
<input type="hidden" id="search" class="ti" name="search" value="$search_string" />
EOF
    return $input;
}

sub hdlr_search_string_without_condition {
    my ( $ctx, $args, $cond ) = @_;

    return '' if is_limit();
    my $blog = $ctx->stash('blog');

    my $search_string = $ctx->stash( 'search_string' );
    my $plugin = MT->component("SearchConditionAppender");
    my $condition = ' ' . $plugin->get_config_value('condition', 'blog:'.$blog->id);
    $search_string =~ s/$condition//;
    return $search_string;
}

sub init_request {
    my $plugin = MT->component("SearchConditionAppender");
    my $expire = $plugin->get_config_value('expire', 'system') || ',';

    my $expire = time();
    if ( $expire eq ',' ) {
        $plugin->set_config_value('expire', $expire, 'system');
    }

    my $duration = time() - $expire;
    my $rest_day = 30 - int($duration / (24 * 3600));
    $plugin->set_config_value('rest_day', $rest_day, 'system');
}

sub is_limit {
    my $plugin = MT->component("SearchConditionAppender");
    my $rest_day = $plugin->get_config_value('rest_day', 'system') || 0;
    return ($rest_day > 0) ? 0 : 1;
}

1;
